
function UFunction ()
{
	// Pierwszy współczynnik funkcji ubytku (zależny od materiału rury i materiału transportowego).
	this.u0;
	// Drugi współczynnik funkcji ubytku (zależny od materiału rury i materiału transportowego).
	this.u1;
	// Promień wewnętrzny rury transportowej.
	this.r;
	// Kąt na jakim materiał transportowany przylega do rury.
	this.w0;
	this.sinW0;
	this.cosW0;
	// Kąt naturalnego usypu materiału transportowanego.
	this.b;
	this.tanB;
}

UFunction.prototype.init = function (u0, u1, r, w0, b)
{
	this.u0 = u0;
	this.u1 = u1;
	this.r = r;
	this.w0 = (w0 * Math.PI) / 180;
	this.sinW0 = Math.sin(this.w0);
	this.cosW0 = Math.cos(this.w0);
	this.b = (b * Math.PI) / 180;
	this.tanB = Math.tan(this.b);
}

UFunction.prototype.compute = function (w, m)
{
	var u = 0;
	
	if (Math.abs(w) < this.w0) {
		var cosW = Math.cos(w);
		u = this.sinW0 - Math.sin(Math.abs(w));
		u *= this.tanB;
		u += cosW - this.cosW0;
		u *= this.u1 * this.r * cosW * cosW;
		u += this.u0;
		u *= m;
	}
	
	return u;
}

UFunction.prototype.computeFullAngle = function (n, m, rot)
{
	var dw = (2 * Math.PI) / n;
	var u = [];
	
	for (var w = 0; w <= this.w0; w += dw) {
		u.push(this.compute(w, m));
	}
	
	var shift = Math.round((n * rot) / 360);
	var rotU = [];
	
	for (var i = 0; i < n; i++) {
		rotU.push(0);
	}
	
	for (var i = 0; i < u.length; i++) {
		rotU[(shift + i) % n] = u[i];
		rotU[(shift - i) % n] = u[i];
	}
	
	return rotU;
}

UFunction.prototype.computeFullAngleCumulation = function (n, m, rot, t, delta)
{
	var u = [];
	
	for (var i = 0; i < n; i++) {
		u.push(0);
	}
	
	for (var i = 0; i < t; i++) {
		var v = this.computeFullAngle(n, m, rot + i*delta);
		for (var j = 0; j < n; j++) {
			u[j] += v[j];
		}
	}
	
	return u;
}
